Bug 91167 - [BDW] dEQP has ~1300 broadwell-specific failures
Summary: [BDW] dEQP has ~1300 broadwell-specific failures
Status: RESOLVED FIXED
Alias: None
Product: Mesa
Classification: Unclassified
Component: Drivers/DRI/i965 (show other bugs)
Version: git
Hardware: x86-64 (AMD64) Linux (All)
: medium normal
Assignee: Kenneth Graunke
QA Contact: Intel 3D Bugs Mailing List
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2015-06-30 23:49 UTC by Mark Janes
Modified: 2015-07-08 08:46 UTC (History)
2 users (show)

See Also:
i915 platform:
i915 features:


Attachments
bdw failures and assertions (107.71 KB, text/plain)
2015-06-30 23:49 UTC, Mark Janes
Details
Fix matrix vertex attributes in NIR (2.06 KB, patch)
2015-07-02 04:18 UTC, Kenneth Graunke
Details | Splinter Review

Note You need to log in before you can comment on or make changes to this bug.
Description Mark Janes 2015-06-30 23:49:52 UTC
Created attachment 116836 [details]
bdw failures and assertions

dEQP has a relatively stable set of failures across the supported platforms.  However, on BDW, there are ~1300 more regressions.

BDW failures and assertions attached.
Comment 1 Kenneth Graunke 2015-07-02 01:00:55 UTC
I think these are a NIR related regression.  They work on master with INTEL_DEBUG=vec4vs and they work on 10.6 with INTEL_USE_NIR=0.  (Well, at least the one test I tried...)
Comment 2 Kenneth Graunke 2015-07-02 02:26:28 UTC
I think I probably broke matrix vertex attributes that aren't mat4s.
Comment 3 Kenneth Graunke 2015-07-02 04:18:57 UTC
Created attachment 116863 [details] [review]
Fix matrix vertex attributes in NIR

I think this patch should fix most of them.
Comment 4 Kenneth Graunke 2015-07-02 17:23:28 UTC
FWIW, the patch is on the mailing list:
http://lists.freedesktop.org/archives/mesa-dev/2015-July/088026.html

I've also posted a backport to 10.6 here:
http://lists.freedesktop.org/archives/mesa-stable/2015-July/002746.html
Comment 5 Mark Janes 2015-07-02 19:34:38 UTC
I tested Ken's patch, it fixes 1256 dEQP failures and puts BDW at parity with HSW.
Comment 6 Kenneth Graunke 2015-07-08 08:46:12 UTC
Fixed on master with:

commit 73d0e7f3451eaeb62ac039d2dcee1e1c6787e3db
Author: Kenneth Graunke <kenneth@whitecape.org>
Date:   Wed Jul 1 20:13:00 2015 -0700

    i965/vs: Fix matNxM vertex attributes where M != 4.
    
    Matrix vertex attributes have their columns padded out to vec4s, which
    I was failing to account for.  Scalar NIR expects them to be packed,
    however.
    
    Fixes 1256 dEQP tests on Broadwell.
    
    Cc: mesa-stable@lists.freedesktop.org
    Signed-off-by: Kenneth Graunke <kenneth@whitecape.org>
    Tested-by: Mark Janes <mark.a.janes@intel.com>
    Reviewed-by: Chris Forbes <chrisf@ijw.co.nz>

I believe Emil will pick it up for 10.6.2 as well.


Use of freedesktop.org services, including Bugzilla, is subject to our Code of Conduct. How we collect and use information is described in our Privacy Policy.